/*XXX this should be in an object literal, however i don't know how to insert consts in object lits*/

/*useful constants*/
  const ELEMENT_NODE                   = 1;
  const ATTRIBUTE_NODE                 = 2;
  const TEXT_NODE                      = 3;
  const CDATA_SECTION_NODE             = 4;
  const ENTITY_REFERENCE_NODE          = 5;
  const ENTITY_NODE                    = 6;
  const PROCESSING_INSTRUCTION_NODE    = 7;
  const COMMENT_NODE                   = 8;
  const DOCUMENT_NODE                  = 9;
  const DOCUMENT_TYPE_NODE             = 10;
  const DOCUMENT_FRAGMENT_NODE         = 11;
  const NOTATION_NODE                  = 12;

function DOMTreeToXML(doc) {
var output;//stores the output document
if (doc.nodeType==ELEMENT_NODE) output=ElementNode(doc);
else if (doc.nodeType==DOCUMENT_NODE) output=DocumentNode(doc);
return output;
}

/*************ELEMENT*************/

function ElementNode(node){
var ElementOutput=""; //stores the output
//store nodeName
ElementOutput+="<"+node.nodeName;
//get attributes
for (var x = 0; x < node.attributes.length; x++){
 ElementOutput+=" "+AttributeNode(node.attributes.item(x));
}
//finish element
ElementOutput+=">";
//loop through children
for(var x = 0; x < node.childNodes.length; x++){
 var currentChild = node.childNodes.item(x);
 if (currentChild.nodeType==ELEMENT_NODE) ElementOutput += ElementNode(currentChild);
 else if (currentChild.nodeType==TEXT_NODE) ElementOutput += TextNode(currentChild);
 else if (currentChild.nodeType==COMMENT_NODE) ElementOutput += CommentNode(currentChild);
 else if (currentChild.nodeType==PROCESSING_INSTRUCTION_NODE) ElementOutput += ProcessingInstructionNode(currentChild);
}
//close tag
ElementOutput+="</"+node.nodeName+">";
return ElementOutput;
}

/*************ATTRIBUTE*************/

function AttributeNode(node){
var AttributeOutput="";
return node.name+"="+'"'+node.value+'"';
}

/*************TEXT*************/

function TextNode(node){
return node.nodeValue;
}

/*************PROCESSING INSTRUCTION*************/

function ProcessingInstructionNode(node){
return "<?"+node.data+"?>";
}

/*************COMMENT*************/

function CommentNode(node){
return "<!--"+node.nodeValue+"-->";
}

/*************DOCUMENT*************/

function DocumentNode(node){
var DocumentOutput="";
for (var x = 0; x < node.childNodes.length; x++){
 var currentChild = node.childNodes.item(x);
 if (currentChild.nodeType==ELEMENT_NODE) DocumentOutput += ElementNode(currentChild);
 else if (currentChild.nodeType==TEXT_NODE) DocumentOutput += TextNode(currentChild);
 else if (currentChild.nodeType==COMMENT_NODE) DocumentOutput += CommentNode(currentChild);
 else if (currentChild.nodeType==PROCESSING_INSTRUCTION_NODE) DocumentOutput += ProcessingInstructionNode(currentChild);
}
return DocumentOutput;
}